<!DOCTYPE html>
<html>

<head>
    <meta charset='UTF-8'>
    <title>Animação #02</title>
    <link rel='stylesheet' href='css/estilo.css'>
    <script src='js/jquery.js'></script>
    <style>
        body {
            position: relative;
            background-color: #999;
            color: #000;
        }

        div {
            position: absolute;
            display: inline;
            border: solid 10px #000;
            padding: 50px;
            font-size: 3em;
            background-color: crimson;
        }
    </style>
</head>

<body>
    <div>Animar!</div>

    <script>
        function alterarLargura(valor, duracao, callback) {
            return new Promise((resulve, reject) => {
                resulve($('div').animate({ width: `+=${valor}` }, duracao, callback))
            })
        }

        function moverDiagonal(valor, duracao, callback) {
            return new Promise((resolve, reject) => {
                resolve($('div')
                        .animate({ top: `+=${valor}`, left: `+=${valor}` }, duracao, callback))
            })
        }

        function girar(valor, duracao, callback) {
            return new Promise((resolve, reject) => {
                resolve(
                    $('div').animate({ transform: `+=${valor}` }, {
                        step: function (valor) {
                            $(this).css('transform', `rotate(${valor}deg)`)
                        },
                        duration: duracao
                    }, 'linear', callback)
                )
            })
        }

        alterarLargura(300, 1000)
            .then(alterarLargura(-300, 1000))
            .then(moverDiagonal(300, 1000))
            .then(girar(360, 1000))
            .then(moverDiagonal(-300, 1000))


    </script>
</body>